package com.example.user.opravarobrazku;

import android.annotation.TargetApi;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Environment;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.ImageView;
import android.view.View;
import android.widget.Toast;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;

public class MainActivity extends ActionBarActivity {

    Alert alert;
    String imagePath;
    Bitmap upravenyObrazek;
    boolean generujeseObraz;
    ImageView pred, po;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        alert = new Alert(this);
        generujeseObraz = true;
        pred = (ImageView)findViewById(R.id.pred);
        po = (ImageView)findViewById(R.id.po);


        SimpleFileDialog sfd = new SimpleFileDialog(this, "FileOpen", new SimpleFileDialog.SimpleFileDialogListener() {
            @Override
            public void onChosenDir(String chosenDir) {
                    File file = new File(chosenDir);
                    if (file.exists()) {
                        if (chosenDir.endsWith(".png") || chosenDir.endsWith(".jpg") || chosenDir.endsWith(".jpeg") || chosenDir.endsWith(".bmp")) {
                            imagePath = chosenDir;
                            pred.setImageDrawable(Drawable.createFromPath(chosenDir));
                            DotvorObrazek();
                        } else {
                            alert.show("Soubor", "Vybraného souboru typ není podporován!  (Podporované typy: .png, .jpg, .jpeg, .bmp)");
                        }
                    } else {
                        alert.show("Soubor", "Vybraný soubor neexistuje!");
                    }
            }
        });
        sfd.Default_File_Name = "obrázek.png";
        sfd.chooseFile_or_Dir("/storage");
    }





    @TargetApi(Build.VERSION_CODES.JELLY_BEAN)
    private void DotvorObrazek(){

        generujeseObraz = true;
        Bitmap image = BitmapFactory.decodeFile(imagePath);
        int width = image.getWidth(), height = image.getHeight();
        int[] pixels = new int[width*height];
        image.getPixels(pixels, 0, width, 0, 0, width, height);

        opravObraz(pixels, width);


        Bitmap out = Bitmap.createBitmap(pixels, width, height, Bitmap.Config.RGB_565);
        po.setBackground(new BitmapDrawable(getResources(), out));
        upravenyObrazek = out;
        generujeseObraz = false;

    }






    public void savePictureToFile(View v) {

        SimpleFileDialog sfd = new SimpleFileDialog(this, "FolderChoose", new SimpleFileDialog.SimpleFileDialogListener() {
            @Override
            public void onChosenDir(String chosenDir) {
                if (!generujeseObraz) {
                    if(!chosenDir.equals(Environment.getExternalStorageDirectory().getAbsolutePath())) {

                        File file = new File(chosenDir+"/OpravenyObrazek1.png");
                        int a = 2;
                        while(file.exists()){
                            file = new File(chosenDir+"/OpravenyObrazek"+a+".png");
                            a++;
                        }

                        try {
                            FileOutputStream os = null;
                            try {
                                os = new FileOutputStream(file);
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                            upravenyObrazek.compress(Bitmap.CompressFormat.PNG, 100, os);
                            try {
                                os.flush();
                                os.close();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                            Toast.makeText(MainActivity.this, "Úspěšně uloženo.  \n\n"+file.getAbsolutePath(), Toast.LENGTH_LONG).show();
                        } catch (Exception e) {
                            e.printStackTrace();
                            alert.show("Ukládání", "Někde se stala chyba!");
                        }
                    }else {
                        alert.show("Ukládání", "Nevybral jste žádnou složku!");
                    }
                }
            }
        });
        sfd.Default_File_Name = "složka";
        sfd.chooseFile_or_Dir(Environment.getExternalStorageDirectory().getAbsolutePath());
    }









    public void opravitDalsi(View v){

        Intent i = new Intent(this, MainActivity.class);
        startActivity(i);
        finish();
    }







    private void opravObraz(int[] pixels, int width) {
        int r = 0, l = 0, u = 0, d = 0;
        int a = 0;
        ArrayList<Integer> nedoplnenePixely = new ArrayList<Integer>();


        for (int pixel : pixels) {
            if (pixel == 0) {

                //TODO Kontroluje zda pixel(vpravo, vlevo, nahoře, dole) existuje nebo ne.
                int b = a;
                int w = width;
                b++;
                if (b % w != 0) {
                    b = a;
                    r = pixels[b + 1];
                }


                b = a;
                b++;
                w = width;
                if (b % w != 1) {
                    b = a;
                    l = pixels[b - 1];
                }


                b = a;
                b++;
                w = width;
                if (b - w > 0) {
                    b = a;
                    w = width;
                    u = pixels[b - w];
                }


                b = a;
                b++;
                w = width;
                if (b + w <= pixels.length) {
                    b = a;
                    w = width;
                    d = pixels[b + w];
                }

                long red = 0;
                long green = 0;
                long blue = 0;
                int pocetNeprazdPixelu = 0;


                //TODO Sečte červenou, zelenou, modrou všech okolních pixelů a vydělí počtem nenulových
                for (int i = 0; i < 4; i++) {
                    int p = 0;
                    boolean pokracovat = true;
                    switch (i) {
                        case 0:
                            if (l == 0) pokracovat = false;
                            p = l;
                            break;
                        case 1:
                            if (r == 0) pokracovat = false;
                            p = r;
                            break;
                        case 2:
                            if (u == 0) pokracovat = false;
                            p = u;
                            break;
                        case 3:
                            if (d == 0) pokracovat = false;
                            p = d;
                            break;
                    }

                    if (pokracovat) {
                        red += Color.red(p);
                        green += Color.green(p);
                        blue += Color.blue(p);
                        pocetNeprazdPixelu++;
                    } else {
                    }

                }
                if (pocetNeprazdPixelu != 0) {
                    pixels[a] = Color.rgb((int) red / pocetNeprazdPixelu, (int) green / pocetNeprazdPixelu, (int) blue / pocetNeprazdPixelu);
                } else {
                    nedoplnenePixely.add(a);
                }
            }
            a++;
        }



        ArrayList<Integer> nedoplnenePixely2 = new ArrayList<Integer>();

        for (int positionPixel : nedoplnenePixely) {

            boolean pokrac = true;
            int p = positionPixel;
            p++;


            //TODO Najde nejbližší pixel na vybranou stranu
            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT % widthT != 0 || pT > pixels.length) {
                    widthT = width;
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        r = pixels[pT];
                    } else {
                        p++;
                    }
                } else {
                    pokrac = false;
                    r = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            p--;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT % widthT != 0 || pT >= 0) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        l = pixels[pT];
                    } else {
                        p--;
                    }
                } else {
                    pokrac = false;
                    l = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            int TestWidth = width;
            p -= TestWidth;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT >= 0) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        u = pixels[pT];
                    } else {
                        p -= width;
                    }
                } else {
                    pokrac = false;
                    u = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            TestWidth = width;
            p += TestWidth;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT >= pixels.length) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        d = pixels[pT];
                    } else {
                        p += width;
                    }
                } else {
                    pokrac = false;
                    d = 0;
                }
            }


            int pocetNeprazdPixelu = 0;
            long red = 0, blue = 0, green = 0;

            //TODO Sečte červenou, zelenou, modrou všech nejbližších pixelů a vydělí počtem nenulových
            for (int i = 0; i < 4; i++) {
                p = 0;
                boolean pokracovat = true;
                switch (i) {
                    case 0:
                        if (l == 0) pokracovat = false;
                        p = l;
                        break;
                    case 1:
                        if (r == 0) pokracovat = false;
                        p = r;
                        break;
                    case 2:
                        if (u == 0) pokracovat = false;
                        p = u;
                        break;
                    case 3:
                        if (d == 0) pokracovat = false;
                        p = d;
                        break;
                }

                if (pokracovat) {
                    red += Color.red(p);
                    green += Color.green(p);
                    blue += Color.blue(p);
                    pocetNeprazdPixelu++;
                }

            }


            if (pocetNeprazdPixelu != 0) {
                pixels[positionPixel] = Color.rgb((int) red / pocetNeprazdPixelu, (int) green / pocetNeprazdPixelu, (int) blue / pocetNeprazdPixelu);
            } else {
                nedoplnenePixely2.add(positionPixel);
            }
        }


        ArrayList<Integer> nedoplnenePixely3 = new ArrayList<Integer>();



        for (int positionPixel : nedoplnenePixely2) {

            boolean pokrac = true;
            int p = positionPixel;
            p++;


            //TODO Najde nejbližší pixel na vybranou stranu
            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT % widthT != 0 || pT > pixels.length) {
                    widthT = width;
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        r = pixels[pT];
                    } else {
                        p++;
                    }
                } else {
                    pokrac = false;
                    r = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            p--;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT % widthT != 0 || pT >= 0) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        l = pixels[pT];
                    } else {
                        p--;
                    }
                } else {
                    pokrac = false;
                    l = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            int TestWidth = width;
            p -= TestWidth;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT >= 0) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        u = pixels[pT];
                    } else {
                        p -= width;
                    }
                } else {
                    pokrac = false;
                    u = 0;
                }
            }

            pokrac = true;
            p = positionPixel;
            TestWidth = width;
            p += TestWidth;

            while (pokrac) {
                int widthT = width;
                int pT = p;
                if (pT >= pixels.length) {
                    pT = p;
                    if (pixels[pT] != 0) {
                        pokrac = false;
                        d = pixels[pT];
                    } else {
                        p += width;
                    }
                } else {
                    pokrac = false;
                    d = 0;
                }
            }


            int pocetNeprazdPixelu = 0;
            long red = 0, blue = 0, green = 0;

            //TODO Sečte červenou, zelenou, modrou všech nejbližších pixelů a vydělí počtem nenulových
            for (int i = 0; i < 4; i++) {
                p = 0;
                boolean pokracovat = true;
                switch (i) {
                    case 0:
                        if (l == 0) pokracovat = false;
                        p = l;
                        break;
                    case 1:
                        if (r == 0) pokracovat = false;
                        p = r;
                        break;
                    case 2:
                        if (u == 0) pokracovat = false;
                        p = u;
                        break;
                    case 3:
                        if (d == 0) pokracovat = false;
                        p = d;
                        break;
                }

                if (pokracovat) {
                    red += Color.red(p);
                    green += Color.green(p);
                    blue += Color.blue(p);
                    pocetNeprazdPixelu++;
                }

            }


            if (pocetNeprazdPixelu != 0) {
                pixels[positionPixel] = Color.rgb((int) red / pocetNeprazdPixelu, (int) green / pocetNeprazdPixelu, (int) blue / pocetNeprazdPixelu);
            } else {
                nedoplnenePixely3.add(positionPixel);
            }
        }

        //TODO Nenabarvené pixely nabarví na bílo
        for(int positionPixel : nedoplnenePixely3){
            pixels[positionPixel] = Color.WHITE;
        }
    }
}

