﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace oprava_obrazku
{
    public partial class Form1 : Form
    {
        private RepairImage r;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "PNG obrázky (*.png)|*.png|Všechny soubory (*.*)|*.*";
            ofd.Title = "Vyberte poškozený obrázek";
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                Image img = Image.FromFile(ofd.FileName);
                Bitmap bmp = new Bitmap(img, img.Size);
                draw_image_to_center(bmp, pictureBox1);
                r = new RepairImage(bmp);
            }
        }

        private void draw_image_to_center(Bitmap bmp, PictureBox box)
        {            
            Graphics gr = box.CreateGraphics();
            gr.Clear(box.BackColor);

            //zmenšování obrázku
            int width = bmp.Width, height = bmp.Height;
            if (width >= box.Width && width >= height)
            {
                double zoom = (double)box.Width / (double)width;
                width = box.Width;
                height = (int)((double)height * zoom);
            }
            else if (height > box.Height && height > width)
            {
                double zoom = (double)box.Height / (double)height;
                height = box.Height;
                width = (int)((double)width * zoom);
            }

            gr.DrawImage(bmp, (box.Width - width) / 2, (box.Height - height) / 2, width, height);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (r != null)
            {
                r.Repair();
                draw_image_to_center(r.Image, pictureBox1);
            }
            else
            {
                MessageBox.Show("Nejdřív vyberte obrázek.");
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (r != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.Filter = "PNG obrázky (*.png)|*.png|Všechny soubory (*.*)|*.*";
                if (sfd.ShowDialog() == DialogResult.OK)
                {
                    r.Image.Save(sfd.FileName);
                }
            }
            else
            {
                MessageBox.Show("Nejdřív vyberte obrázek.");
            }
        }
    }
}
